let getAuthLoading = false;
Page({
  data: {
    userAuth: false,
    stepAuth: false
  },
  
  onLoad(options) {
    let data = {};
    if (options.userAuth === 'true') {
      data.userAuth = true;
    } else if (options.userAuth === 'false') {
      data.userAuth = false;
    }
    if (options.stepAuth === 'true') {
      data.stepAuth = true;
    } else if (options.stepAuth === 'false') {
      data.stepAuth = false;
    }
    console.log(data)
    this.setData(data);
  },

  getUserAuth(event) {
    if (getAuthLoading) return;
    getAuthLoading = true;
    if (event.detail.errMsg === 'getUserInfo:ok') {
      console.log('getUserAuth:ok', event.detail)
      this.setData({
        userAuth: true
      });
      setTimeout(() => {
        getAuthLoading = false;
      }, 100);
    } else {
      console.log('getUserAuth:fail', event)
    }
  },

  getStepAuth() {
    if (getAuthLoading) return;
    getAuthLoading = true;
    wx.authorize({
      scope: 'scope.werun',
      success:() => {
        this.userAuthorizedStep();
      },
      fail:() => {
        // 调起用户授权窗口失败，因为用户曾经拒绝过，而且在这里不能直接去到openSetting页，需要通过一个弹窗中转过去
        wx.showModal({
          content: '授权失败，请在接下来的页面中同意授权',
          showCancel: false,
          success:() => {
            wx.openSetting({
              success:(res) => {
                if (res.authSetting['scope.werun']) {
                  this.userAuthorizedStep();
                }
              }
            });
          }
        });
      },
      complete: () => {
        setTimeout(() => {
          getAuthLoading = false;
        }, 100);
      }
    });
  },

  userAuthorizedStep() {
    this.setData({
      stepAuth: true
    });
    wx.getWeRunData({
      success(res) {
        console.log('getWeRunData', res)
      }
    });
  }
})